#lang racket
(provide abstract-manager%)

;---------------------------------------------------------------------------------------------------
;abstract resource manager
;concrete resource managers, such as exercise-manager% will extend abstract-manager%

;resource managers communicate with dodona-client% to manage a certain resource on the dodona server.
;---------------------------------------------------------------------------------------------------

(define abstract-manager%
  (class object%
    (init-field host client)
    (super-new)

    (define/public (url endpoint) ;prepends host to given endpoint
      (string-append host endpoint))

    (define/public (get-all-pages-data resource-url)
      ;given a full resource-url, such as http://dodona.localhost:3000/nl/series/92/activities.json
      ;get all of the data of that url accross all pages
      (let loop ((current-data (send client get resource-url))
                 (counter 2))
        (let ((next-page-data (send client get (string-append resource-url (format "?page=~a" counter)))))
          (if (null? next-page-data)
              current-data
              (loop (append current-data next-page-data)
                    (+ counter 1))))))
    ))
              
