#lang racket
(require "abstract-manager.rkt")
(require "../resources/series.rkt")
(provide series-manager%)

;---------------------------------------------------------------------------------------------------
;series-manager% communicates with dodona-client% to manage series on the dodona server.
;E.g. fetch a series (which is a resource) from the server.
;---------------------------------------------------------------------------------------------------

(define series-manager%
  (class abstract-manager%
    (init dodona-host dodona-client)
    (super-new [host dodona-host]
               [client dodona-client])

    (inherit url)
    (inherit-field client)
    (inherit-field host)

    (define series-endpoint "/series/~a")

    (define/public (get-all course) ;get all series of a course
      (let ((series-url (send course get-series-url)))
        (map (lambda (series-data)
               (new series% [series-data series-data]))
             (send client get series-url))))

    (define/public (get id) ;gets a specific series
      (let ((series-url (url (format series-endpoint id))))
        (new series% [series-data (send client get series-url)])))))
