#lang racket
(require "abstract-manager.rkt")
(require "../resources/user.rkt")

(provide user-manager%)

;---------------------------------------------------------------------------------------------------
;user-manager% communicates with dodona-client% to manage users on the dodona server.
;E.g. fetch a user (which is a resource) from the server.
;---------------------------------------------------------------------------------------------------

(define user-manager%
  (class abstract-manager%
    (init dodona-host dodona-client)
    (super-new [host dodona-host]
               [client dodona-client])

    (inherit url)
    (inherit-field client)
    (inherit-field host)

    (define endpoint-users "/users/~a") ;call format with it

    (define/public (get-user id)
      (let* ((user-data (send client get (url (format endpoint-users id)))))
        (new user% [user-data user-data])))))
