#lang racket
(provide course%)

;---------------------------------------------------------------------------------------------------
;course% represents a course (resource) on the Dodona server.
;So, data associated with a course is encapsulated
;---------------------------------------------------------------------------------------------------

(define course%
  (class object%
    (super-new)
    (init-field course-data)

    (define/private (lookup key)
      (hash-ref course-data key))

    (define/public (get-color)
      (lookup 'color))

    (define/public (get-id)
      (lookup 'id))

    (define/public (get-name)
      (lookup 'name))

    (define/public (get-teacher)
      (lookup 'teacher))

    (define/public (get-series-url) ;gets url to series
      (lookup 'series))

    (define/public (get-year)
      (lookup 'year))

    (define/public (get-url)
      (lookup 'url))

    ))