#lang racket
(provide exercise%)
(require "programming-language.rkt")

;---------------------------------------------------------------------------------------------------
;exercise% represents a course (resource) on the Dodona server.
;So, data associated with an exercise is encapsulated
;---------------------------------------------------------------------------------------------------

(define exercise%
  (class object%
    (init-field exercise-data)
    (super-new)

    (define/private (lookup key)
      (hash-ref exercise-data key))

    (define/public (get-boilerplate)
      (lookup 'boilerplate))

    (define/public (get-has-correct-solution?)
      (lookup 'has_correct_solution))

    (define/public (get-has-solution?)
      (lookup 'has_solution))

    (define/public (get-id)
      (lookup 'id))

    (define/public (get-last-solution-is-best?)
      (lookup 'last_solution_is_best))

    (define/public (get-name)
      (lookup 'name))

    (define/public (get-url)
      (lookup 'url))

    (define/public (get-programming-language)
      (new programming-language%
           [prog-lang-data (lookup 'programming_language)]))
    
    ))

    
    