#lang racket
(provide series%)

;---------------------------------------------------------------------------------------------------
;series% represents a series (resource) on the Dodona server.
;So, data associated with a series is encapsulated
;---------------------------------------------------------------------------------------------------

(define series%
  (class object%
    (init-field series-data)
    (super-new)

    (define/private (lookup key)
      (hash-ref series-data key))

    (define/public (get-deadline)
      (lookup 'deadline)) ;deadline might be null

    (define/public (get-description)
      (lookup 'description))

    (define/public (get-exercises-url)
      (lookup 'exercises))

    (define/public (get-id)
      (lookup 'id))

    (define/public (get-name)
      (lookup 'name))

    (define/public (get-order)
      (lookup 'order))

    (define/public (get-visibility)
      (lookup 'visibility))

    (define/public (get-url)
      (lookup 'url))
     
    ))

    
    
      
