#lang racket
(provide submission-info%)
(require json)

;---------------------------------------------------------------------------------------------------
;submission-info% represents info about a submission (resource) on the Dodona server.
;So, data associated with it is encapsulated
;---------------------------------------------------------------------------------------------------

(define submission-info%
  (class object%
    (init-field submission-info-data)
    (super-new)

    (define/private (lookup key)
      (hash-ref submission-info-data key))

    (define/public (get-accepted?)
      (lookup 'accepted))

    (define/public (get-creation-timestamp)
      (lookup 'created_at))

    (define/public (get-exercise-url)
      (lookup 'exercise))

    (define/public (get-id)
      (lookup 'id))

    (define/public (get-status)
      (lookup 'status))

    (define/public (get-summary)
      (lookup 'summary))

    (define/public (get-url)
      (lookup 'url))     
    ))


                

