#lang racket
(require "../resources/course.rkt") 
(provide user%)

;---------------------------------------------------------------------------------------------------
;user% represents a user (resource) on the Dodona server.
;So, data associated with a user is encapsulated
;---------------------------------------------------------------------------------------------------

(define user%
  (class object%
    (init-field user-data)
    (super-new)

    (define/private (lookup key)
      (hash-ref user-data key))

    (define/public (get-email)
      (lookup 'email))

    (define/public (get-correct-exercises)
      (lookup 'correct_exercises))

    (define/public (get-first-name)
      (lookup 'first_name))

    (define/public (get-id)
      (lookup 'id))

    (define/public (get-last-name)
      (lookup 'last_name))

    (define/public (get-submission-count)
      (lookup 'submission_count))

    (define/public (get-submissions-url)
      (lookup 'submissions))

    (define/public (get-subscribed-courses)
      (map (lambda (subscribed-course-data)
             (new course% [course-data subscribed-course-data]))
           (lookup 'subscribed_courses)))
    
    (define/public (get-username)
      (lookup 'username))
    ))



    
    
      
