#lang racket
(provide root-response%)
(require "../resources/series.rkt")
(require "../resources/user.rkt")

;-------------------------------------------------------------------------------------------------------------
;RESPONES: After certain HTTP requests, the dodona server responds with some data.
;
;root-response: dodona servers response after a GET request on the host url (i.e: GET http://127.0.0.1:3000)
;-------------------------------------------------------------------------------------------------------------

(define root-response%
  (class object%
    (init-field root-response-data)
    (super-new)

    (define/private (lookup key)
      (hash-ref root-response-data key))

    (define/public (get-deadline-series)
      (map (lambda (series-data)
             (new series% [series-data series-data]))
           (lookup 'deadline_series)))

    (define/public (get-user)
      (new user% [user-data (lookup 'user)]))))