#lang racket
(require rackunit)
(require "../../../dodona-api/dodona-client.rkt")
(require "../../../dodona-api/resources/course.rkt")
(require "../resource-validators.rkt")
(require "../constants.rkt")

(test-case "USER MANAGER TEST"
           (define client (new dodona-client% [host DODONA-TEST-URL] [token "zeus"]))
           (define course-manager (get-field course-manager client))

           (define submission-manager (get-field submission-manager client)) ;needed to fetch a submission
           (define submission-id 1)
           (define fetched-submission (send submission-manager get submission-id))
           (validate-submission fetched-submission)

           (define course-id 3)
           (define first-course (send course-manager get-course course-id))
           (validate-course first-course)

           (define second-course (send course-manager get-course fetched-submission))
           (validate-course second-course))
