#lang racket
(require rackunit)
(require "../../../dodona-api/dodona-client.rkt")
(require "../../../dodona-api/resources/submission.rkt")
(require "../resource-validators.rkt")
(require "../constants.rkt")

(define my-obj 0)

;;Layered test
(test-case "SUBMISSION TEST TEST"

           ;;Layer 1: Get a submission% object
           (define client (new dodona-client% [host DODONA-TEST-URL] [token "zeus"]))

           (define submission-manager (get-field submission-manager client))
           (define a-submission-id #f)

           (let* ((courseID 9)
                  (seriesID 86)
                  (exerciseID 805381696)
                  (first-post-response (send submission-manager submit courseID seriesID exerciseID "(define (sign n) 1)")))

             (define id (send first-post-response get-id))
             (sleep 10)
             (define submission (send submission-manager get id)) ;submission holds the submission% object

             ;;Layer 2: get a submission-test% object, and test it
             (define submission-test (send submission get-submission-test))

             (set! my-obj submission-test)

             (check-true (boolean? (send submission-test get-accepted?)))
             (check-true (string? (send submission-test get-description)))
             (check-true (string? (send submission-test get-tests-description)))
             (check-true (is-a? (car (send submission-test get-test-tabs)) test-tab%))

             ;;Layer B: get a test-tab% object, and test it
             (define test-tab (car (send submission-test get-test-tabs)))
             (check-true (number? (send test-tab get-badge-count)))
             (check-true (string? (send test-tab get-description)))
             (check-true (is-a? (car (send test-tab get-test-groups)) test-group%))

             ;;Layer 3: get a test-group% object, and test it
             (define test-group (car (send test-tab get-test-groups)))
             (check-true (boolean? (send test-group get-accepted?)))
             (check-true (string? (send test-group get-description )))
             (check-true (is-a? (car (send test-group get-test-cases)) test-case%))

             ;;Layer 4: get a test-case% object, and test it
             (define test-case (car (send test-group get-test-cases)))
             (check-true (boolean? (send test-case get-accepted)))
             (check-true (string? (send test-case get-description)))

             ;;Layer 5: get a test-case-tests% object, and test it
             (define test-case-tests (car (send test-case get-test-case-tests)))
             (check-true (boolean? (send test-case-tests get-accepted)))
             (check-true (string? (send test-case-tests get-test-code)))
             (check-true (string? (send test-case-tests get-expected)))
             (check-true (string? (send test-case-tests get-generated)))))
